#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "atima.h"
#include "mocadi.h"
float sisigan(	
		double d_ap,	    /* mass of projectile */
		int i_zp,	    /* charge of projectile */
		double d_en_in,     /* energy of projectile in front of material */
		double d_en_out,    /* energy of projectile behind material */
		double d_at,           /* mass number of target */
		int i_zt)           /* charge of target */
{
 /*******************************************************************/
 /*                                                                 */
 /* this function calculates the anguler straggling of a particle   */
 /* with mass i_ap and charge i_zp with energy i_en_anf when it     */
 /* traverses a target with (d_at,d_zt)                             */
 /*                                                                 */
 /* all external-felder muessen vorher besetzt sein                */
 /*            besetzen mit : call sirera                           */
 /*                                                                 */
 /*******************************************************************/
  extern int i_asave[I_SAVE_MAX+1];
  extern int i_zsave[I_SAVE_MAX+1];
  extern int i_fsave[I_SAVE_MAX+1];
  extern struct splines atima_spline[120][I_SAVE_MAX+1];
  extern int b_check;
  double  d_range, dedx, astragg;
  int i_save; 
 
  if(b_check)printf("   sisigan: sisigan is working\n");
 
  for(i_save = 1;i_save <= I_SAVE_MAX;i_save++){  /*tabelle schon gespeichert*/
    if ((i_zsave[i_save] >  200 )&&(i_zsave[i_save] == i_zt))goto L1;
    if (i_zsave[i_save] == i_zt)goto L1;
  }
  printf("**SISIGAN ERR* system error\n");
  printf("The matter(Z=%d,A=%lf) doesn't exist stored list\n",i_zt,d_at);
  mocadi_abort(-77);
L1: 

  /* avoid error for transuranium cases, remove for full set of splines !!!*/
  if(i_fsave[i_save]==0){
    if(i_zp>120) i_zp=92 ;
  }
  else if(i_fsave[i_save]==1){
    if(i_zp>92) i_zp=92 ;
  }

  /* for thin target use da2/dE * dE, else spline differences */
  if(1. - d_en_out/d_en_in < 1e-3) {
    astragg = ( atima_da2de(&atima_spline[i_zp-1][i_save], d_en_in)
	      + atima_da2de(&atima_spline[i_zp-1][i_save], d_en_out)) /2
              * (d_en_in-d_en_out);
    astragg = sqrt(astragg * atima_spline[i_zp-1][i_save].m_projectile/d_ap);
  }
  else {
    astragg = atima_astragg(&atima_spline[i_zp-1][i_save], d_en_in, d_en_out)
             *sqrt(atima_spline[i_zp-1][i_save].m_projectile/d_ap);
  }
  return(astragg);
}
