#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "atima.h"
#include "mocadi.h"
double sirange1(
	double 	d_ap,		/* mass   of projectile*/
	int 	i_zp,		/* charge of projectile*/
	double 	d_energy,	/* energy of projectile*/
   //	int 	i_at,		/* mass   of target    */
	double 	d_at,		/* mass   of target    */
	int 	i_zt)		/* charge of target    */
{ 
 /*******************************************************************/
 /*                                                                 */
 /* this function calculates thge range of a particle with          */
 /* (d_ap,d_zp) with energy (d_energy) when traversing a target     */
 /* with (d_at,d_zt).                                               */
 /*                                                                 */
 /* aufruf:                                                         */
 /*    reichweite     = sirange(.........)                          */
 /*                                                                 */
 /* all external array must have been preset with valid numbers     */
 /*                                                                 */
 /*******************************************************************/
  extern int i_asave[I_SAVE_MAX+1];
  extern int i_zsave[I_SAVE_MAX+1];
  extern int i_fsave[I_SAVE_MAX+1];
  extern double d_asave[I_SAVE_MAX+1];
  extern struct splines atima_spline[120][I_SAVE_MAX+1];
  
  extern int b_check;
  double d_t;
  double d_range,
	 d_en_ver;
  int i,k;
  int i_save;
 
  if(b_check)printf("   sirange: sirange wird abgearbeitet\n");
 
  if(b_check){
     printf ("%lf\n",d_at);
     printf ("%d\t%d\t%d\t%d\t%d\t\n",
	     i_asave[1],i_asave[2],i_asave[3],i_asave[4],i_asave[5]);
     printf ("%d\t%d\t%d\t%d\t%d\t\n",
	     i_zsave[1],i_zsave[2],i_zsave[3],i_zsave[4],i_zsave[5]);
  }
 
  for(i_save = 1;i_save<=I_SAVE_MAX;i_save++){
    if (i_zsave[i_save]>200&&i_zsave[i_save]==i_zt) goto L1;
/*    if (i_asave[i_save]==i_at&&i_zsave[i_save]==i_zt) goto L1;*/
    if (i_zsave[i_save]==i_zt) goto L1;
  }
  printf("**SIRANGE ERR* system error\n");
  printf("The matter(Z=%d,A=%lf) doesn't exist stored list\n",i_zt,d_at);
  mocadi_abort(-70);
L1:  
  if(atima_spline[i_zp-1][i_save].z_target[0]==i_zt)goto L2;
  printf("**SIRANGE ERR* system error\n");
  printf("The matter(Z=%d,A=%lf) doesn't exist stored list\n",i_zt,d_at);
  mocadi_abort(-70);
L2:
  if (i_zsave[i_save]>200){
    d_range = d_ap/atima_spline[i_zp-1][i_save].m_projectile*
        atima_range(&atima_spline[i_zp-1][i_save], d_energy);
  }
  else{// if(fabs(d_at-d_asave[i_save])>1e-2){
    d_range = d_ap/atima_spline[i_zp-1][i_save].m_projectile*
      d_at/d_asave[i_save]*
	atima_range(&atima_spline[i_zp-1][i_save], d_energy);
  }
  /*else{
    d_range = d_ap/atima_spline[i_zp-1][i_save].m_projectile*
	atima_range(&atima_spline[i_zp-1][i_save], d_energy);
  }
  */

  return(d_range);
}
