#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "atima.h"
#include "mocadi.h"
void sisigra1(	
		double d_ap,		/* mass   of projectile */
		int    i_zp,		/* charge of projectile */
		double d_energy,	/* energy of projectile */
     //		int    i_at,		/* mass   of target     */
		double    d_at,		/* mass   of target     */
		int    i_zt,		/* charge of target     */
		double *d_range,	/* range                */
		double *d_sigra)	/* range stragling      */
{
 /*******************************************************************/
 /*                                                                 */
 /* this function calculates range and straggling for a particle    */
 /* with (d_ap,d_zp) and energy (d_energy) when                     */
 /* traversing a target with (d_at,d_zt).                           */
 /*                                                                 */
 /* alle external-felder muessen vorher besetzt sein                */
 /*                                                                 */
 /*******************************************************************/

  extern int i_asave[I_SAVE_MAX+1],i_zsave[I_SAVE_MAX+1],i_fsave[I_SAVE_MAX+1];
  extern double d_asave[I_SAVE_MAX+1];
  extern struct splines atima_spline[120][I_SAVE_MAX+1]; 
  extern int b_check; 
  int i_save;
  int i_zpold=0;
  
  if(b_check)printf("   sisigra: sisigra wird abgearbeitet\n\n");
  for(i_save = 1;i_save <=I_SAVE_MAX; i_save++){
    if ((i_zsave[i_save]> 200 )&&(i_zsave[i_save]==i_zt)) goto L1;
/*    if ((i_zsave[i_save]==i_zt)&&(i_asave[i_save]==i_at)) goto L1;*/
    if (i_zsave[i_save]==i_zt) goto L1;
  }
  printf("**SISIGRA ERR* system error\n");
  printf("The matter(Z=%d,A=%lf) doesn't exist in stored list\n",i_zt,d_at);
  mocadi_abort(-81);
 L1:

  /* for transuranium case, pretend to be U and scale later */
  if(i_fsave[i_save]==0){
    if(i_zp>120){
      i_zpold = i_zp ;
      i_zp = 120;
    }
  }
  else if(i_fsave[i_save]==0){
    if(i_zp>92){
      i_zpold = i_zp ;
      i_zp = 92;
    }
  }

  //  printf("at=%lf atimaat=%lf \n",d_at, d_asave[i_save]);

  /*	printf("%d %lf %d %lf %d %d %d %lf\n",
	atima_spline[i_zp-1][i_save].Zt,
	atima_spline[i_zp-1][i_save].At,
	atima_spline[i_zp-1][i_save].Zp,
	atima_spline[i_zp-1][i_save].Ap,
	i_zt,i_at,i_zp,d_ap);
	*/	              
  if(i_zt> 200 ){
    *d_range =  d_ap/atima_spline[i_zp-1][i_save].m_projectile*
      atima_range(&atima_spline[i_zp-1][i_save], d_energy);
    *d_sigra = sqrt(d_ap/atima_spline[i_zp-1][i_save].m_projectile
                    *atima_sigra2(&atima_spline[i_zp-1][i_save],d_energy));
  }
  else{// if(fabs(d_at-d_asave[i_save])>1e-2){
    *d_range =  d_ap/atima_spline[i_zp-1][i_save].m_projectile*
      d_at/d_asave[i_save]*
      atima_range(&atima_spline[i_zp-1][i_save], d_energy);
    *d_sigra = sqrt( d_ap/atima_spline[i_zp-1][i_save].m_projectile
		     //                    *d_at/d_asave[i_save]
                    *atima_sigra2(&atima_spline[i_zp-1][i_save], d_energy))
                    *d_at/d_asave[i_save];
  }

  /*  else{
    *d_range =  d_ap/atima_spline[i_zp-1][i_save].m_projectile*
      atima_range(&atima_spline[i_zp-1][i_save], d_energy);
    *d_sigra = sqrt( d_ap/atima_spline[i_zp-1][i_save].m_projectile
                    *atima_sigra2(&atima_spline[i_zp-1][i_save], d_energy));
  }

  */
  /* for transuranium case scale with Z^2 */
  if(i_fsave[i_save]==0){
    if(i_zpold>120){
      *d_range = *d_range * pow(1.*i_zp/i_zpold,2);
      *d_sigra = *d_sigra * pow(1.*i_zp/i_zpold,2);
    }
  }
  else if(i_fsave[i_save]==1){
    if(i_zpold>92){
      *d_range = *d_range * pow(1.*i_zp/i_zpold,2);
      *d_sigra = *d_sigra * pow(1.*i_zp/i_zpold,2);
    }
  }

}
